Orthanc Plugin SDK: OrthancPlugins::IDatabaseBackend Class Reference

| Orthanc Plugin SDK 1.3.0 Documentation of the plugin interface of Orthanc

Public Member Functions | Protected Member Functions | List of all members
OrthancPlugins::IDatabaseBackend Class Referenceabstract
Callbacks
Inheritance diagram for OrthancPlugins::IDatabaseBackend:

## Public Member Functions
void | RegisterOutput (DatabaseBackendOutput *output)
virtual void | Open ()=0
virtual void | Close ()=0
virtual void | AddAttachment (int64_t id, const OrthancPluginAttachment &attachment)=0
virtual void | AttachChild (int64_t parent, int64_t child)=0
virtual void | ClearChanges ()=0
virtual void | ClearExportedResources ()=0
virtual int64_t | CreateResource (const char *publicId, OrthancPluginResourceType type)=0
virtual void | DeleteAttachment (int64_t id, int32_t attachment)=0
virtual void | DeleteMetadata (int64_t id, int32_t metadataType)=0
virtual void | DeleteResource (int64_t id)=0
virtual void | GetAllInternalIds (std::list< int64_t > &target, OrthancPluginResourceType resourceType)=0
virtual void | GetAllPublicIds (std::list< std::string > &target, OrthancPluginResourceType resourceType)=0
virtual void | GetAllPublicIds (std::list< std::string > &target, OrthancPluginResourceType resourceType, uint64_t since, uint64_t limit)=0
virtual void | GetChanges (bool &done, int64_t since, uint32_t maxResults)=0
virtual void | GetChildrenInternalId (std::list< int64_t > &target, int64_t id)=0
virtual void | GetChildrenPublicId (std::list< std::string > &target, int64_t id)=0
virtual void | GetExportedResources (bool &done, int64_t since, uint32_t maxResults)=0
virtual void | GetLastChange ()=0
virtual void | GetLastExportedResource ()=0
virtual void | GetMainDicomTags (int64_t id)=0
virtual std::string | GetPublicId (int64_t resourceId)=0
virtual uint64_t | GetResourceCount (OrthancPluginResourceType resourceType)=0
virtual OrthancPluginResourceType | GetResourceType (int64_t resourceId)=0
virtual uint64_t | GetTotalCompressedSize ()=0
virtual uint64_t | GetTotalUncompressedSize ()=0
virtual bool | IsExistingResource (int64_t internalId)=0
virtual bool | IsProtectedPatient (int64_t internalId)=0
virtual void | ListAvailableMetadata (std::list< int32_t > &target, int64_t id)=0
virtual void | ListAvailableAttachments (std::list< int32_t > &target, int64_t id)=0
virtual void | LogChange (const OrthancPluginChange &change)=0
virtual void | LogExportedResource (const OrthancPluginExportedResource &resource)=0
virtual bool | LookupAttachment (int64_t id, int32_t contentType)=0
virtual bool | LookupGlobalProperty (std::string &target, int32_t property)=0
virtual void | LookupIdentifier (std::list< int64_t > &target, OrthancPluginResourceType resourceType, uint16_t group, uint16_t element, OrthancPluginIdentifierConstraint constraint, const char *value)=0
virtual bool | LookupMetadata (std::string &target, int64_t id, int32_t metadataType)=0
virtual bool | LookupParent (int64_t &parentId, int64_t resourceId)=0
virtual bool | LookupResource (int64_t &id, OrthancPluginResourceType &type, const char *publicId)=0
virtual bool | SelectPatientToRecycle (int64_t &internalId)=0
virtual bool | SelectPatientToRecycle (int64_t &internalId, int64_t patientIdToAvoid)=0
virtual void | SetGlobalProperty (int32_t property, const char *value)=0
virtual void | SetMainDicomTag (int64_t id, uint16_t group, uint16_t element, const char *value)=0
virtual void | SetIdentifierTag (int64_t id, uint16_t group, uint16_t element, const char *value)=0
virtual void | SetMetadata (int64_t id, int32_t metadataType, const char *value)=0
virtual void | SetProtectedPatient (int64_t internalId, bool isProtected)=0
virtual void | StartTransaction ()=0
virtual void | RollbackTransaction ()=0
virtual void | CommitTransaction ()=0
virtual uint32_t | GetDatabaseVersion ()=0
virtual void | UpgradeDatabase (uint32_t targetVersion, OrthancPluginStorageArea *storageArea)=0
virtual void | ClearMainDicomTags (int64_t internalId)=0

## Protected Member Functions
DatabaseBackendOutput & | GetOutput ()

## Member Function Documentation

## ◆ UpgradeDatabase()

virtual void OrthancPlugins::IDatabaseBackend::UpgradeDatabase | ( | uint32_t | targetVersion,
|  | OrthancPluginStorageArea * | storageArea
| ) |  |
| pure virtual

Upgrade the database to the specified version of the database schema. The upgrade script is allowed to make calls to OrthancPluginReconstructMainDicomTags().

The documentation for this class was generated from the following file:

- OrthancCppDatabasePlugin.h